/*Autor: Ylva Brandt, Juni 2020
Dieses Werk ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Weitergabe unter gleichen Bedingungen 4.0 International Lizenz (http://creativecommons.org/licenses/by-nc-sa/4.0/).
Sie erlaubt Download und Weiterverteilung des vollständigen Werkes unter Nennung meines Namens, jedoch keinerlei kommerzielle Nutzung. Die Weitergabe von Bearbeitungen dieses Werkes ist erlaubt, solange ich als Urheber des Originals genannt werde und die auf diesem Werk basierenden neuen Werke unter denselben Bedingungen veröffentlicht werden.
*/

/* Bedienung über Tasten:
   r: zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
   i: invertieren der Farben
   s: abspeichern der aktuellen Version des Bildes
*/


import static javax.swing.JOptionPane.*; //import für die Verwendung einer Dialogbox für die Eingabe des Anwenders

PImage meinBild; //Variable, die das zu bearbeitende Bild aufnimmt

void setup(){
  size(600, 800); //Die Größe des Fensters wird auf die Größe des Bildes festgelegt.
  meinBild = loadImage("IMG_2798_600x800.jpg"); //Das Bild wird in der globalen Variablen meinBild gespeichert
  image(meinBild, 0, 0); //Das Bild in der Variablen meinBild wird im Programmfenster angezeigt.
  loadPixels(); //Die Reihung pixels wird mit den Farbwerten des angezeigten Bildes gefüllt. Ein erneutes Laden erfolgt erst beim Ausführen eines Resets. Dadurch können perspektivisch mehrere Funktionen zur Manipulationen hintereinander ausgeführt werden. 
}

void draw()// Diese Methode muss enthalten sein, damit die Anzeige des Bildes akutalisiert wird. 
{
}

void keyPressed(){// über die Tasten wird die Funktion ausgewählt, die auf das Bild angewendet werden soll
  switch(key){
    case 'r': reset(); //zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
              break;
    case 'i': invertieren(); // invertieren der Farben
              break;
    case 's': save("bildBearbeitung.png"); //abspeichern der aktuellen Version des Bildes
              break;
              
  }
}

//Invertieren der RGB-Werte
 void invertieren(){
    for(int i = 0; i < pixels.length; i++){//Es wird jeder einzelne Bildpunkt in der Reihung pixels bearbeitet
        color col = pixels[i]; //Der RGB-Wert des i-ten Bildpunktes wird in der Variablen col vom Datentyp color gespeichert
        //Variablen für den aktuellen Rot-, Grün- und Blauwert.
        //Mithilfe der Methoden red(), green() und blue() können der Rot-, Grün- bzw. Blauanteil aus einer Variablen vom Typ color extrahiert werden.
        float rot = 255-red(col); 
        float gruen = 255-green(col);
        float blau = 255-blue(col);
        pixels[i] = color(rot, gruen, blau); //Es wird eine neue Farbe erzeugt, die in einer Variablen vom Datentyp color gespeichert werden kann. Hier wird sie an Position i  in der Reihung vom Typ color gespeichert. 
        }
    updatePixels(); // Die aktuellen Werte in der Reihung pixels werden für die Anzeige des Bildes übernommen.  
  }

   
  //zurücksetzen auf das Originalbild
  void reset(){
   image(meinBild, 0, 0, width, height); //zurücksetzen der Anzeige auf das Originalbild   
   loadPixels(); //laden der Pixel des Originalbildes in die Reihung pixels
  }
