/*Autor: Ylva Brandt, Juni 2020
Dieses Werk ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Weitergabe unter gleichen Bedingungen 4.0 International Lizenz (http://creativecommons.org/licenses/by-nc-sa/4.0/).
Sie erlaubt Download und Weiterverteilung des vollständigen Werkes unter Nennung meines Namens, jedoch keinerlei kommerzielle Nutzung. Die Weitergabe von Bearbeitungen dieses Werkes ist erlaubt, solange ich als Urheber des Originals genannt werde und die auf diesem Werk basierenden neuen Werke unter denselben Bedingungen veröffentlicht werden.
*/

/* Bedienung über Tasten:
   r: zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
   i: invertieren der Farben
   g: Erzeugen eines Graustufenbildes aufgrund der durchschnittlichen Helligkeit
   2: Erzeugen eines Graustufenbildes mit dem Maximum der Farbanteile als Definition der Helligkeit 
   h: Verändern der Helligkeit nach der Vorgabe des Anwenders, Werte zwischen -50 und 50 möglich 
   k: Erhöhen des Kontrastes mit exemplarischer Rechnung
   v: Verringern des Kontrastes mit exemplarischer Rechnung
   p: Erzeugen eines Sepia-Effektes
   s: abspeichern der aktuellen Version des Bildes
*/


import static javax.swing.JOptionPane.*; //import für die Verwendung einer Dialogbox für die Eingabe des Anwenders

PImage meinBild; //Variable, die das zu bearbeitende Bild aufnimmt
//Variablen für den aktuellen Rot-, Grün- und Blauwert. Könnten bei dieser Implementierung auch jeweils als lokale Variable definiert werden.
float rot;  
float gruen;
float blau;
int zaehler = 1; // Zaehler, um mehrere Versionen des Bildes abspeichern zu können. 
//Hat den Nachteil, dass der Zähler bei jedem Neustart des Programms wieder bei 1 beginnt.
//Alternativ könnten eine Nummer oder ein vollstänidger Dateiname vom Anwender erfragt werden.


void setup(){
  size(600, 800); //Die Größe des Fensters wird auf die Größe des Bildes festgelegt.
  meinBild = loadImage("IMG_2798_600x800.jpg"); //Das Bild wird in der globalen Variablen meinBild gespeichert
  image(meinBild, 0, 0); //Das Bild in der Variablen meinBild wird im Programmfenster angezeigt.
  loadPixels(); //Die Reihung pixels wird mit den Farbwerten des angezeigten Bildes gefüllt. Ein erneutes Laden erfolgt erst beim Ausführen eines Resets. Dadurch können mehrere Funktionen zur Manipulationen hintereinander ausgeführt werden. 
}

void draw()// Diese Methode muss enthalten sein, damit die Anzeige des Bildes akutalisiert wird. 
{
}

void keyPressed(){// über die Tasten wird die Funktion ausgewählt, die auf das Bild angewendet werden soll
  switch(key){
    case 'r': reset(); //zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
              break;
    case 'i': invertieren(); // invertieren der Farben
              break;
    case 'g': graustufen(); //Erzeugen eines Graustufenbildes aufgrund der durchschnittlichen Helligkeit
              break;
    case '2': graustufen2(); //Erzeugen eines Graustufenbildes mit dem Maximum der Farbanteile als Definition der Helligkeit 
              break;
    case 'h': helligkeit(); //Verändern der Helligkeit nach der Vorgabe des Anwenders, Werte zwischen -50 und 50 möglich 
              break;
    case 'k': kontrast(); //Erhöhen des Kontrastes mit exemplarischer Rechnung
              break;
    case 'v': kontrastV(); //Verringern des Kontrastes mit exemplarischer Rechnung
              break;
    case 'p': sepia(); //Erzeugen eines Sepia-Effektes
              break;
    case 's': save("bildBearbeitung" + zaehler+".png"); //abspeichern der aktuellen Version des Bildes
              zaehler++;
              break;
              
  }
  
 
}

//Invertieren der RGB-Werte
 void invertieren(){
    for(int i = 0; i < pixels.length; i++){//Es wird jeder einzelne Bildpunkt in der Reihung pixels bearbeitet
        color col = pixels[i]; //Der RGB-Wert des i-ten Bildpunktes wird in der Variablen col vom Datentyp color gespeichert
        rot = 255- red(col); //Mithilfe der Methoden red(), green() und blue() können der Rot-, Grün- bzw. Blauanteil aus einer Variablen vom Typ color extrahiert werden.
        gruen = 255-green(col);
        blau = 255-blue(col);
        pixels[i] = color(rot, gruen, blau); //Es wird eine neue Farbe erzeugt, die in einer Variablen vom Datentyp color gespeichert werden kann. Hier wird sie an Position i  in der Reihung vom Typ color gespeichert. 
        }
    updatePixels(); // Die aktuellen Werte in der Reihung pixels werden für die Anzeige des Bildes übernommen.  
  }

 //Erzeugen eines Graustufenbildes aufgrund der durchschnittlichen Helligkeit 
 void graustufen(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        float grau = (red(col) + green(col) + blue(col))/3; //Berechnen der Helligkeit als Durchschnitt des Rot-, Grün- und Blauanteils 
        pixels[i] = color(grau);
    }
    updatePixels();    
  }
  
//Erzeugen eines Graustufenbildes mit dem Maximum der Farbanteile als Definition der Helligkeit  
 void graustufen2(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        float grau = max(red(col), max(green(col), blue(col))); //Bestimmen des Maximums der drei Farbanteile
        pixels[i] = color(grau);
    }
    updatePixels();    
  }
  
 //Erzeugen eines Sepia-Effektes 
 void sepia(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        gruen = (red(col) + green(col) + blue(col))/3; //Der Grünwert wird als Druchschnitt der drei Farbanteile festgelegt
        rot = gruen + 30; //Der Rotwert ist 30 höher als der Grünwert, maximal 255
        if(rot > 255) rot = 255;
        blau = gruen - 20; //Der Grünwert ist 20 niedriger als der Grünwert, mindestens 0
        if(blau < 0) blau = 0;
        pixels[i] = color(rot, gruen, blau);
    }
    updatePixels();    
  }
  
 void helligkeit(){
   try{
     int summand = Integer.parseInt(showInputDialog("Bitte gib einen Wert zwischen -50 und 50 ein, um den die Helligkeit verringert bzw. erhöht werden soll."));
     for(int i = 0; i < pixels.length; i++){//Die Farbanteile werden jeweils um den Wert, den der Anwender eingegeben hat, erhöht bzw. verringert. Verlässt ein Wert dabei den gültigen Bereich zwischen 0 und 255, wird er auf 0 bzw. 255 gesetzt.
        color col = pixels[i];
        rot = red(col) + summand;
        if(rot < 0) rot = 0;
        if(rot > 255) rot = 255;
        gruen = green(col)+summand;
        if(gruen < 0) gruen = 0;
        if(gruen > 255) gruen = 255;
        blau = blue(col)+summand;
        if(blau < 0) blau = 0;
        if(blau > 255) blau = 255;
        pixels[i] = color(rot, gruen, blau);
      }
    updatePixels();
    }catch(NumberFormatException e){
     System.out.println("Bitte geben Sie eine ganze Zahl zwischen -50 und 50 ein.");
   }
  }
  
  //Erhöhen des Kontrastes
  void kontrast(){
    for(int i = 0; i < pixels.length; i++){
        color col = pixels[i]; //Exemplarische Funktion zum erhöhen des Kontrastes. Multiplikation mit einem Faktor zum Strecken des Wertebereichs. Subtraktion einer Konstante, um einem generellen Aufhellen entgegenzuwirken.
        rot = red(col) * 1.2 - 20;
        if(rot < 0) rot = 0;
        if(rot > 255) rot = 255;
        gruen = green(col)* 1.2 - 20;
        if(gruen < 0) gruen = 0;
        if(gruen > 255) gruen = 255;
        blau = blue(col)* 1.2 - 20;
        if(blau < 0) blau = 0;
        if(blau > 255) blau = 255;
        pixels[i] = color(rot, gruen, blau);
    }
    updatePixels();    
  }
  
  //Verringern der Kontrastes 
   void kontrastV(){
   loadPixels();
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i]; //exemplarische Funktion analog zum Erhöhen des Kontrastes: Faktor unter 1 zum Verkleinern des Wertebereichs. Addition einer Konstante zum Ausgleichen der Vedunkelung.
        rot = red(col) * 0.8 + 20;
        if(rot < 0) rot = 0;
        if(rot > 255) rot = 255;
        gruen = green(col)*  0.8 + 20;
        if(gruen < 0) gruen = 0;
        if(gruen > 255) gruen = 255;
        blau = blue(col)*  0.8 + 20;
        if(blau < 0) blau = 0;
        if(blau > 255) blau = 255;
        pixels[i] = color(rot, gruen, blau);
    }
    updatePixels();    
  }
  
  //zurücksetzen auf das Originalbild
  void reset(){
   image(meinBild, 0, 0, width, height); //zurücksetzen der Anzeige auf das Originalbild   
   loadPixels(); //laden der Pixel des Originalbildes in die Reihung pixels
  }
