/*Autor: Ylva Brandt, Juni 2020
Dieses Werk ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Weitergabe unter gleichen Bedingungen 4.0 International Lizenz (http://creativecommons.org/licenses/by-nc-sa/4.0/).
Sie erlaubt Download und Weiterverteilung des vollständigen Werkes unter Nennung meines Namens, jedoch keinerlei kommerzielle Nutzung. Die Weitergabe von Bearbeitungen dieses Werkes ist erlaubt, solange ich als Urheber des Originals genannt werde und die auf diesem Werk basierenden neuen Werke unter denselben Bedingungen veröffentlicht werden.
Das beiliegende Bild ist ein Ausschnitt eines Fotos, das von Tom Fisk bei Pexels zur kostenlosen Nutzung zur Verfügung gestellt wird: (https://www.pexels.com/de-de/foto/antennenlandschaft-baume-drohne-drohne-cam-1486463/).
*/

/* Bedienung über Tasten:
   z: zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
   r: Erstellen des Rotauszugs
   g: Erstellen des Grünauszugs
   b: Erstellen des Blauauszugs 
   c: Erstellen einer Farbkodierung für ein Graustufenbild 
   f: Erstellen eines Falschfarbenbildes   
   s: Abspeichern der aktuellen Version des Bildes
*/



PImage meinBild; //Variable, die das zu bearbeitende Bild aufnimmt
int zaehler = 1; // Zaehler, um mehrere Versionen des Bildes abspeichern zu können. 
//Hat den Nachteil, dass der Zähler bei jedem Neustart des Programms wieder bei 1 beginnt.
//Alternativ könnten eine Nummer oder ein vollstänidger Dateiname vom Anwender erfragt werden.


void setup(){
  size(600, 400); //Die Größe des Fensters wird auf die Größe des Bildes festgelegt.
  meinBild = loadImage("landschaft_ausschnitt.jpg"); //Das Bild wird in der globalen Variablen meinBild gespeichert
  image(meinBild, 0, 0); //Das Bild in der Variablen meinBild wird im Programmfenster angezeigt.
  loadPixels(); //Die Reihung pixels wird mit den Farbwerten des angezeigten Bildes gefüllt. Ein erneutes Laden erfolgt erst beim Ausführen eines Resets.  
}

void draw()// Diese Methode muss enthalten sein, damit die Anzeige des Bildes akutalisiert wird. 
{
}

void keyPressed(){// über die Tasten wird die Funktion ausgewählt, die auf das Bild angewendet werden soll
  switch(key){
    case 'z': reset(); //zurücksetzen der Anzeige und der Reihung pixels auf das Original des Bildes 
              break;
    case 'r': rotauszug(); //Erstellen des Rotauszugs
              break;
    case 'g': gruenauszug(); //Erstellen des Grünauszugs
              break;
    case 'b': blauauszug(); //Erstellen des Blauauszugs
              break;
    case 'f': falschfarben(); //Erstellen eines Falschfarbenbildes   
              break;
    case 'c': codierung(); //Erstellen einer Farbkodierung für ein Graustufenbild
              break;
    case 's': save("bildBearbeitung" + zaehler+".png"); //abspeichern der aktuellen Version des Bildes
              zaehler++;
              break;     
  }
}

//Erstellen des Rotauszugs
 void rotauszug(){
    for(int i = 0; i < pixels.length; i++){//Es wird jeder einzelne Bildpunkt in der Reihung pixels bearbeitet
        color col = pixels[i]; //Der RGB-Wert des i-ten Bildpunktes wird in der Variablen col vom Datentyp color gespeichert
        pixels[i] = color(red(col)); //Der Rotanteil wird als Grauton übernommen 
        }
    updatePixels(); // Die aktuellen Werte in der Reihung pixels werden für die Anzeige des Bildes übernommen.  
  }

//Erstellen des Grünauszugs analog zum Rotauszug
 void gruenauszug(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        pixels[i] = color(green(col));
    }
    updatePixels();    
  }
 
//Erstellen des Blauauszugs analog zum Rotauszug
 void blauauszug(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        pixels[i] = color(blue(col));
    }
    updatePixels();    
  }
  
//Erstellen eines Falschfarbenbildes   
 void falschfarben(){
   for(int i = 0; i < pixels.length; i++){
        color col = pixels[i];
        pixels[i] = color(green(col), blue(col), red(col)); //Die Farbkanäle werden vertauscht.
    }
    updatePixels();    
  }

 //Erstellen einer Farbkodierung für ein Graustufenbild, liegt kein Graustufenbild vor, wird der Grünwert cordiert
 void codierung(){
   for(int i = 0; i < pixels.length; i++){
     //Auslesen des Grünwertes für jeden einzelnen Pixel
      color col = pixels[i];
      float gruen = green(col);
      //Der Grünwert wird in neun Intervalle eingeteilt. Je nachdem in welches Intervall der Grünwert fällt, wird dem Pixel eine von neun Farben zugewiesen 
      if(gruen < 30){
        pixels[i] = color(0, 0, 0);
      }
      if(30 <= gruen && gruen < 60){
        pixels[i] = color(0, 0, 255);
      }
      if(60 <= gruen && gruen < 90){
        pixels[i] = color(0, 120, 255);
      }
      if(90 <= gruen && gruen < 120){
        pixels[i] = color(0, 255, 0);
      }
      if(120 <= gruen && gruen < 150){
        pixels[i] = color(255, 255, 0);
      }
      if(150 <= gruen && gruen < 180){
        pixels[i] = color(255, 120, 0);
      }
      if(180 <= gruen && gruen < 210){
        pixels[i] = color(255, 0, 255);
      }
      if(210 <= gruen && gruen < 240){
        pixels[i] = color(255, 0, 0);
      }
      if(240 <= gruen){
        pixels[i] = color(255, 255, 255);
      }
      }
    updatePixels();
    
  }
  
  
  //zurücksetzen auf das Originalbild
  void reset(){
   image(meinBild, 0, 0, width, height); //zurücksetzen der Anzeige auf das Originalbild   
   loadPixels(); //laden der Pixel des Originalbildes in die Reihung pixels
  }
