/* Autor: Ylva Brandt, Juni 2020
* Dieses Werk ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Weitergabe unter gleichen Bedingungen 4.0 International Lizenz (http://creativecommons.org/licenses/by-nc-sa/4.0/).
* Sie erlaubt Download und Weiterverteilung des vollständigen Werkes unter Nennung meines Namens, jedoch keinerlei kommerzielle Nutzung. Die Weitergabe von Bearbeitungen dieses Werkes ist erlaubt, 
* solange ich als Urheber des Originals genannt werde und die auf diesem Werk basierenden neuen Werke unter denselben Bedingungen veröffentlicht werden.
*/ 


/* Anleitung: 
* Mit der rechten Maustaste kann ein Pixel als Referenzpunkt für ausgewählt werden.
* Mit der linken Maustaste kann ein Pixel zum Vergleich ausgewählt werden.
*/


import static javax.swing.JOptionPane.*; //import zur Verwendung des Dialogfensters mit dem Anwender

PImage meinBild; //Variable, die das zu bearbeitende Bild aufnimmt
color refColor; //Referenz-RGB-Wert für die Zauberstabfunktion


void setup(){
  size(600, 800); //Die Größe des Fensters wird auf die Größe des Bildes festgelegt.
  meinBild = loadImage("Foto_Meer_600x800.jpg"); //Das Bild wird in der globalen Variablen meinBild gespeichert
  image(meinBild, 0, 0); //Das Bild in der Variablen meinBild wird im Programmfenster angezeigt.
  loadPixels(); //Die RGB-Werte des aktuell angezeigten Bildes werden in die Variable pixels (Reihung vom Typ color) geladen
}

void draw()// Diese Methode muss enthalten sein, damit auf Mausklicks reagiert wird. 
{
}

void mouseClicked(){
 if(mouseButton == RIGHT){//Auf das Klicken der rechten Maustaste wird mit Festlegen des Referenzwertes reagiert
  refColor = pixels[mouseX + mouseY*width]; //Bestimmen des Index der Reihung pixels aus x+y*Breite des Fensters
  println("("+(int)red(refColor) + ", " + (int)green(refColor) + ", " + (int)blue(refColor) + ")"); //Ausgabe des RGB-Wertes
 }
 if(mouseButton == LEFT){//Auf Klicken der linken Maustaste wird mit Vergleichen mit dem Referenzwert reagiert 
   int toleranzwert = (int)(Float.parseFloat(showInputDialog("Bitte gib den Toleranzwert in Prozent ein!"))*255/100);  //Die Eingabe des Toleranzwertes erfolgt in Prozent. Daraus wird dann der absolute Wert berechnet, um den die einzelnen Farbanteile abweichen dürfen
   color col = pixels[mouseX + mouseY*width]; //RGB-Wert des ausgewählten Pixels
   println("("+(int)red(col) + ", " + (int)green(col) + ", " + (int)blue(col) + ")"); //Ausgeben des RGB-Wertes des ausgewählten Pixels
   println("farblich uebereinstimmend: " + vergleicheRGBWerte(col, refColor, toleranzwert)); //ausgeben des Vergleichsergergebnisses der RGB-Werte
 }
}
 
 //Hilfmethode zum Überprüfen ob zwei RGB-Werte unter Berücksichtigung des Toleranzwertes farblich übereinstimmen sind 
 boolean vergleicheRGBWerte(color col1, color col2, int abweichung){
    boolean gleich = false;
    //Die Rot-, Grün- und Blauwerte werden jeweils verglichen. Dabei muss die Differenz der Werte kleiner als der Toleranzwert sein, damit die Werte als übereinstimmend gewertet werden.   
    if((abs(red(col1) - red(col2)) < abweichung) &&
        (abs(green(col1) - green(col2)) < abweichung) && 
        (abs(blue(col1) - blue(col2)) < abweichung)){
        gleich = true;
    }
    return gleich;
}
